Index: branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3115)
+++ branches/2011/dev_NEMO_MERGE_2011/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3116)
@@ -184,154 +660,4 @@
 
 
-      ! Read discrete distance and mapping indices
-      ! ******************************************
-      nbidta(:,:) = 0.e0
-      nbjdta(:,:) = 0.e0
-      nbrdta(:,:) = 0.e0
-
-      IF( cp_cfg == "eel" .AND. jp_cfg == 5 ) THEN
-         icount = 0
-         DO ir = 1, nn_rimwidth                  ! Define west boundary (from ii=2 to ii=1+nn_rimwidth):
-            DO ij = 3, jpjglo-2
-               icount = icount + 1
-               nbidta(icount,:) = ir + 1 + (jpizoom-1)
-               nbjdta(icount,:) = ij     + (jpjzoom-1) 
-               nbrdta(icount,:) = ir
-            END DO
-         END DO
-         !
-         DO ir = 1, nn_rimwidth                  ! Define east boundary (from ii=jpiglo-1 to ii=jpiglo-nn_rimwidth):
-            DO ij=3,jpjglo-2
-               icount = icount + 1
-               nbidta(icount,:) = jpiglo-ir + (jpizoom-1)
-               nbidta(icount,2) = jpiglo-ir-1 + (jpizoom-1) ! special case for u points
-               nbjdta(icount,:) = ij + (jpjzoom-1)
-               nbrdta(icount,:) = ir
-            END DO
-         END DO
-         !       
-      ELSE            ! Read indices and distances in unstructured boundary data files 
-         !
-         IF( ln_tides ) THEN             ! Read tides input files for preference in case there are no bdydata files
-            clfile(4) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_T.nc'
-            clfile(5) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_U.nc'
-            clfile(6) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_V.nc'
-         ENDIF
-         IF( ln_dyn_fla .AND. .NOT. ln_tides ) THEN 
-            clfile(4) = cn_dta_fla_T
-            clfile(5) = cn_dta_fla_U
-            clfile(6) = cn_dta_fla_V
-         ENDIF
-
-         IF( ln_tra_frs ) THEN 
-            clfile(1) = cn_dta_frs_T
-            IF( .NOT. ln_dyn_frs ) THEN 
-               clfile(2) = cn_dta_frs_T     ! Dummy read re read T file for sake of 6 files
-               clfile(3) = cn_dta_frs_T     !
-            ENDIF
-         ENDIF          
-         IF( ln_dyn_frs ) THEN 
-            IF( .NOT. ln_tra_frs )   clfile(1) = cn_dta_frs_U      ! Dummy Read 
-            clfile(2) = cn_dta_frs_U
-            clfile(3) = cn_dta_frs_V 
-         ENDIF
-
-         !                                   ! how many files are we to read in?
-         IF(ln_tides .OR. ln_dyn_fla)   igrd_start = 4
-         !
-         IF(ln_tra_frs    ) THEN   ;   igrd_start = 1
-         ELSEIF(ln_dyn_frs) THEN   ;   igrd_start = 2
-         ENDIF
-         !
-         IF( ln_tra_frs   )   igrd_end = 1
-         !
-         IF(ln_dyn_fla .OR. ln_tides) THEN   ;   igrd_end = 6
-         ELSEIF( ln_dyn_frs             ) THEN   ;   igrd_end = 3
-         ENDIF
-
-         DO igrd = igrd_start, igrd_end
-            CALL iom_open( clfile(igrd), inum )
-            id_dummy = iom_varid( inum, 'nbidta', kdimsz=kdimsz )  
-            IF(lwp) WRITE(numout,*) 'kdimsz : ',kdimsz
-            ib_len = kdimsz(1)
-            IF( ib_len > jpbdta)   CALL ctl_stop(  'Boundary data array in file too long.',                  &
-                &                                  'File :', TRIM(clfile(igrd)),'increase parameter jpbdta.' )
-
-            CALL iom_get( inum, jpdom_unknown, 'nbidta', zdta(1:ib_len,:) )
-            DO ii = 1,ib_len
-               nbidta(ii,igrd) = INT( zdta(ii,1) )
-            END DO
-            CALL iom_get( inum, jpdom_unknown, 'nbjdta', zdta(1:ib_len,:) )
-            DO ii = 1,ib_len
-               nbjdta(ii,igrd) = INT( zdta(ii,1) )
-            END DO
-            CALL iom_get( inum, jpdom_unknown, 'nbrdta', zdta(1:ib_len,:) )
-            DO ii = 1,ib_len
-               nbrdta(ii,igrd) = INT( zdta(ii,1) )
-            END DO
-            CALL iom_close( inum )
-
-            IF( igrd < 4) THEN            ! Check that rimwidth in file is big enough for Frs case(barotropic is one):
-               ibr_max = MAXVAL( nbrdta(:,igrd) )
-               IF(lwp) WRITE(numout,*)
-               IF(lwp) WRITE(numout,*) ' Maximum rimwidth in file is ', ibr_max
-               IF(lwp) WRITE(numout,*) ' nn_rimwidth from namelist is ', nn_rimwidth
-               IF (ibr_max < nn_rimwidth)   CALL ctl_stop( 'nn_rimwidth is larger than maximum rimwidth in file' )
-            ENDIF !Check igrd < 4
-            !
-         END DO
-         !
-      ENDIF 
-
-      ! Dispatch mapping indices and discrete distances on each processor
-      ! *****************************************************************
-     
-      iw = mig(1) + 1            ! if monotasking and no zoom, iw=2
-      ie = mig(1) + nlci-1 - 1   ! if monotasking and no zoom, ie=jpim1
-      is = mjg(1) + 1            ! if monotasking and no zoom, is=2
-      in = mjg(1) + nlcj-1 - 1   ! if monotasking and no zoom, in=jpjm1
-
-      DO igrd = igrd_start, igrd_end
-         icount  = 0
-         icountr = 0
-         nblen   (igrd) = 0
-         nblenrim(igrd) = 0
-         nblendta(igrd) = 0
-         DO ir=1, nn_rimwidth
-            DO ib = 1, jpbdta
-               ! check if point is in local domain and equals ir
-               IF(  nbidta(ib,igrd) >= iw .AND. nbidta(ib,igrd) <= ie .AND.   &
-                  & nbjdta(ib,igrd) >= is .AND. nbjdta(ib,igrd) <= in .AND.   &
-                  & nbrdta(ib,igrd) == ir  ) THEN
-                  !
-                  icount = icount  + 1
-                  !
-                  IF( ir == 1 )   icountr = icountr+1
-                  IF (icount > jpbdim) THEN
-                     IF(lwp) WRITE(numout,*) 'bdy_ini: jpbdim too small'
-                     nstop = nstop + 1
-                  ELSE
-                     nbi(icount, igrd)  = nbidta(ib,igrd)- mig(1)+1
-                     nbj(icount, igrd)  = nbjdta(ib,igrd)- mjg(1)+1
-                     nbr(icount, igrd)  = nbrdta(ib,igrd)
-                     nbmap(icount,igrd) = ib
-                  ENDIF            
-               ENDIF
-            END DO
-         END DO
-         nblenrim(igrd) = icountr !: length of rim boundary data on each proc
-         nblen   (igrd) = icount  !: length of boundary data on each proc        
-      END DO 
-
-      ! Compute rim weights
-      ! -------------------
-      DO igrd = igrd_start, igrd_end
-         DO ib = 1, nblen(igrd)
-            nbw(ib,igrd) = 1.- TANH( FLOAT( nbr(ib,igrd) - 1 ) *0.5 )                     ! tanh formulation
-!           nbw(ib,igrd) = (FLOAT(nn_rimwidth+1-nbr(ib,igrd))/FLOAT(nn_rimwidth))**2      ! quadratic
-!           nbw(ib,igrd) =  FLOAT(nn_rimwidth+1-nbr(ib,igrd))/FLOAT(nn_rimwidth)          ! linear
-         END DO
-      END DO 
-   
       ! Mask corrections
       ! ----------------
@@ -361,22 +687,30 @@
       ! bdy masks and bmask are now set to zero on boundary points:
       igrd = 1       ! In the free surface case, bmask is at T-points
-      DO ib = 1, nblenrim(igrd)     
-        bmask(nbi(ib,igrd), nbj(ib,igrd)) = 0.e0
-      END DO
+      DO ib_bdy = 1, nb_bdy
+        DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)     
+          bmask(idx_bdy(ib_bdy)%nbi(ib,igrd), idx_bdy(ib_bdy)%nbj(ib,igrd)) = 0.e0
+        ENDDO
+      ENDDO
       !
       igrd = 1
-      DO ib = 1, nblenrim(igrd)      
-        bdytmask(nbi(ib,igrd), nbj(ib,igrd)) = 0.e0
-      END DO
+      DO ib_bdy = 1, nb_bdy
+        DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)      
+          bdytmask(idx_bdy(ib_bdy)%nbi(ib,igrd), idx_bdy(ib_bdy)%nbj(ib,igrd)) = 0.e0
+        ENDDO
+      ENDDO
       !
       igrd = 2
-      DO ib = 1, nblenrim(igrd)
-        bdyumask(nbi(ib,igrd), nbj(ib,igrd)) = 0.e0
-      END DO
+      DO ib_bdy = 1, nb_bdy
+        DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
+          bdyumask(idx_bdy(ib_bdy)%nbi(ib,igrd), idx_bdy(ib_bdy)%nbj(ib,igrd)) = 0.e0
+        ENDDO
+      ENDDO
       !
       igrd = 3
-      DO ib = 1, nblenrim(igrd)
-        bdyvmask(nbi(ib,igrd), nbj(ib,igrd)) = 0.e0
-      END DO
+      DO ib_bdy = 1, nb_bdy
+        DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
+          bdyvmask(idx_bdy(ib_bdy)%nbi(ib,igrd), idx_bdy(ib_bdy)%nbj(ib,igrd)) = 0.e0
+        ENDDO
+      ENDDO
 
       ! Lateral boundary conditions
@@ -384,20 +718,24 @@
       CALL lbc_lnk( bdyumask(:,:), 'U', 1. )   ;   CALL lbc_lnk( bdyvmask(:,:), 'V', 1. )
 
-      IF( ln_vol .OR. ln_dyn_fla ) THEN      ! Indices and directions of rim velocity components
-         !
+      DO ib_bdy = 1, nb_bdy       ! Indices and directions of rim velocity components
+
+         idx_bdy(ib_bdy)%flagu(:) = 0.e0
+         idx_bdy(ib_bdy)%flagv(:) = 0.e0
+         icount = 0 
+
          !flagu = -1 : u component is normal to the dynamical boundary but its direction is outward
          !flagu =  0 : u is tangential
          !flagu =  1 : u is normal to the boundary and is direction is inward
-         icount = 0 
-         flagu(:) = 0.e0
- 
+  
          igrd = 2      ! u-component 
-         DO ib = 1, nblenrim(igrd)  
-            zefl=bdytmask(nbi(ib,igrd)  , nbj(ib,igrd))
-            zwfl=bdytmask(nbi(ib,igrd)+1, nbj(ib,igrd))
-            IF( zefl + zwfl ==2 ) THEN
-               icount = icount +1
+         DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)  
+            nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
+            nbj => idx_bdy(ib_bdy)%nbj(ib,igrd)
+            zefl = bdytmask(nbi  ,nbj)
+            zwfl = bdytmask(nbi+1,nbj)
+            IF( zefl + zwfl == 2 ) THEN
+               icount = icount + 1
             ELSE
-               flagu(ib)=-zefl+zwfl
+               idx_bdy(ib_bdy)%flagu(ib)=-zefl+zwfl
             ENDIF
          END DO
@@ -406,14 +744,15 @@
          !flagv =  0 : u is tangential
          !flagv =  1 : u is normal to the boundary and is direction is inward
-         flagv(:) = 0.e0
 
          igrd = 3      ! v-component
-         DO ib = 1, nblenrim(igrd)  
-            znfl = bdytmask(nbi(ib,igrd), nbj(ib,igrd))
-            zsfl = bdytmask(nbi(ib,igrd), nbj(ib,igrd)+1)
-            IF( znfl + zsfl ==2 ) THEN
+         DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)  
+            nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
+            nbj => idx_bdy(ib_bdy)%nbj(ib,igrd)
+            znfl = bdytmask(nbi,nbj  )
+            zsfl = bdytmask(nbi,nbj+1)
+            IF( znfl + zsfl == 2 ) THEN
                icount = icount + 1
             ELSE
-               flagv(ib) = -znfl + zsfl
+               idx_bdy(ib_bdy)%flagv(ib) = -znfl + zsfl
             END IF
          END DO
@@ -422,5 +761,5 @@
             IF(lwp) WRITE(numout,*)
             IF(lwp) WRITE(numout,*) ' E R R O R : Some data velocity points,',   &
-               ' are not boundary points. Check nbi, nbj, indices.'
+               ' are not boundary points. Check nbi, nbj, indices for boundary set ',ib_bdy
             IF(lwp) WRITE(numout,*) ' ========== '
             IF(lwp) WRITE(numout,*)
@@ -428,5 +767,5 @@
          ENDIF 
     
-      ENDIF
+      ENDDO
 
       ! Compute total lateral surface for volume correction:
@@ -435,46 +774,41 @@
       IF( ln_vol ) THEN  
          igrd = 2      ! Lateral surface at U-points
-         DO ib = 1, nblenrim(igrd)
-            bdysurftot = bdysurftot + hu     (nbi(ib,igrd)  ,nbj(ib,igrd))                      &
-               &                    * e2u    (nbi(ib,igrd)  ,nbj(ib,igrd)) * ABS( flagu(ib) )   &
-               &                    * tmask_i(nbi(ib,igrd)  ,nbj(ib,igrd))                      &
-               &                    * tmask_i(nbi(ib,igrd)+1,nbj(ib,igrd))                   
-         END DO
+         DO ib_bdy = 1, nb_bdy
+            DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
+               nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
+               nbj => idx_bdy(ib_bdy)%nbi(ib,igrd)
+               flagu => idx_bdy(ib_bdy)%flagu(ib)
+               bdysurftot = bdysurftot + hu     (nbi  , nbj)                           &
+                  &                    * e2u    (nbi  , nbj) * ABS( flagu ) &
+                  &                    * tmask_i(nbi  , nbj)                           &
+                  &                    * tmask_i(nbi+1, nbj)                   
+            ENDDO
+         ENDDO
 
          igrd=3 ! Add lateral surface at V-points
-         DO ib = 1, nblenrim(igrd)
-            bdysurftot = bdysurftot + hv     (nbi(ib,igrd),nbj(ib,igrd)  )                      &
-               &                    * e1v    (nbi(ib,igrd),nbj(ib,igrd)  ) * ABS( flagv(ib) )   &
-               &                    * tmask_i(nbi(ib,igrd),nbj(ib,igrd)  )                      &
-               &                    * tmask_i(nbi(ib,igrd),nbj(ib,igrd)+1)
-         END DO
+         DO ib_bdy = 1, nb_bdy
+            DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
+               nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
+               nbj => idx_bdy(ib_bdy)%nbi(ib,igrd)
+               flagv => idx_bdy(ib_bdy)%flagv(ib)
+               bdysurftot = bdysurftot + hv     (nbi, nbj  )                           &
+                  &                    * e1v    (nbi, nbj  ) * ABS( flagv ) &
+                  &                    * tmask_i(nbi, nbj  )                           &
+                  &                    * tmask_i(nbi, nbj+1)
+            ENDDO
+         ENDDO
          !
          IF( lk_mpp )   CALL mpp_sum( bdysurftot )      ! sum over the global domain
       END IF   
-
-      ! Initialise bdy data arrays
-      ! --------------------------
-      tbdy(:,:) = 0.e0
-      sbdy(:,:) = 0.e0
-      ubdy(:,:) = 0.e0
-      vbdy(:,:) = 0.e0
-      sshbdy(:) = 0.e0
-      ubtbdy(:) = 0.e0
-      vbtbdy(:) = 0.e0
-#if defined key_lim2
-      frld_bdy(:) = 0.e0
-      hicif_bdy(:) = 0.e0
-      hsnif_bdy(:) = 0.e0
-#endif
-
-      ! Read in tidal constituents and adjust for model start time
-      ! ----------------------------------------------------------
-      IF( ln_tides )   CALL tide_data
       !
+      ! Tidy up
+      !--------
+      DEALLOCATE(nbidta, nbjdta, nbrdta)
+
    END SUBROUTINE bdy_init
 
 #else
    !!---------------------------------------------------------------------------------
-   !!   Dummy module                                   NO unstructured open boundaries
+   !!   Dummy module                                   NO open boundaries
    !!---------------------------------------------------------------------------------
 CONTAINS
